Index: /trunk/VUT/GtpVisibilityPreprocessor/scripts/Preprocessor.vcproj
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/scripts/Preprocessor.vcproj	(revision 498)
+++ /trunk/VUT/GtpVisibilityPreprocessor/scripts/Preprocessor.vcproj	(revision 508)
@@ -156,5 +156,6 @@
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
+"
 						Outputs="$(InputDir)moc_$(InputName).cpp"/>
 				</FileConfiguration>
@@ -225,4 +226,7 @@
 			<File
 				RelativePath="..\src\Parser.h">
+			</File>
+			<File
+				RelativePath="..\src\Plane3.cpp">
 			</File>
 			<File
@@ -251,5 +255,6 @@
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
+"
 						Outputs="$(InputDir)moc_$(InputName).cpp"/>
 				</FileConfiguration>
@@ -265,5 +270,6 @@
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
+"
 						Outputs="$(InputDir)moc_$(InputName).cpp"/>
 				</FileConfiguration>
@@ -367,4 +373,13 @@
 			<File
 				RelativePath="..\src\ViewCellsManager.h">
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsParser.cpp">
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsParser.h">
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsParserXerces.h">
 			</File>
 			<File
Index: /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 508)
@@ -15,5 +15,5 @@
 	filename ../data/atlanta/atlanta2.x3d
 #	filename ../data/soda/soda.dat
-#	filename ../data/soda/soda5.dat
+	filename ../data/soda/soda5.dat
 }
 
@@ -21,5 +21,5 @@
 	# stored sample rays
 	samplesFilename rays.out
-	useGlRenderer true
+	useGlRenderer false
 #	type sampling
 	type vss
@@ -28,11 +28,18 @@
 
 VssPreprocessor {
-	samplesPerPass  100000
-	initialSamples 500000
-	vssSamples 2000000
+	samplesPerPass  500000
+	initialSamples 200000
+	vssSamples 200000
 	vssSamplesPerPass 100000
 	useImportanceSampling true
 	loadInitialSamples  false
 	storeInitialSamples false
+	useViewSpaceBox true
+}
+
+
+SamplingPreprocessor {
+	totalSamples 500000
+	samplesPerPass  3
 }
 
@@ -160,11 +167,8 @@
 
 
-Sampling {
-	totalSamples 300000
-	samplesPerPass  3
-}
 
 ViewCells {
 	loadFromFile false
+	exportToFile true
 	#type kdTree
 	#type vspKdTree
@@ -176,7 +180,6 @@
 	height 5.0
 	maxViewCells 500
-	maxPvs 200
-	
-	
+	maxPvs 500
+		
 	PostProcess {
 		# how much samples are used for post processing
@@ -192,5 +195,5 @@
 		colorCode Random
 		exportRays false
-		exportGeometry false
+		exportGeometry true
 	}
 	
@@ -199,4 +202,5 @@
 #	filename ../data/vienna/viewcells-25.x3d
 #	filename ../data/vienna/viewcells-large-sel.x3d
+	filename ../scripts/viewcells.xml
 }
 
@@ -220,9 +224,9 @@
 		maxDepth	 	40
 		minPvs			50
-		minRays			300
+		minRays			700
 		minSize			0.001
 		maxCostRatio		0.9
 		missTolerance		4
-		maxRayContribution 	0.5
+		maxRayContribution 	0.05
 	}
 	
@@ -260,6 +264,6 @@
 	# balanced rays        = 512
 	# pvs                  = 1024
-
-	splitPlaneStrategy 1024
+	
+	splitPlaneStrategy 1026
 	
 	# maximal candidates for split planes
@@ -268,5 +272,5 @@
 	
 	# maximal tested rays for split cost heuristics
-	maxTests 2000
+	maxTests 10000
 	
 	# factors for evaluating split plane costs
@@ -279,19 +283,24 @@
 	Termination {
 		# parameters used for autopartition
-		minRays 		200
+		minRays 		500
 		minPolygons 		-1
 		maxDepth		30
 		minPvs 			20
-		#minArea 		0.0001
-		minArea 		0.000
-		maxRayContribution	0.05
-		maxCostRatio		0.9
+		minArea 		0.0001
+		#minArea 		0.000
+		maxRayContribution	0.5
+		maxCostRatio		0.95
 		missTolerance		5
 		#maxAccRayLength	100
 		
-		maxViewCells		20000
+		maxViewCells		200000
 		
 		# used for pvs criterium
 		ct_div_ci 0.0
+		
+		AxisAligned {
+			minRays 		2000
+			maxRayContribution	0.5
+		}
 	}
 	
@@ -305,5 +314,5 @@
 	PostProcess {
 		maxCostRatio 0.1
-		minViewCells 500
+		minViewCells 200
 		maxPvsSize   1000
 		useRaysForMerge true
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 508)
@@ -34,4 +34,6 @@
 class VspBspTree 
 {
+	friend class ViewCellsParseHandlers;
+
 public:
 	
@@ -180,8 +182,4 @@
 	BspNode *GetRoot() const;
 
-	/** Exports VspBsp tree to file.
-	*/
-	bool Export(const string filename);
-
 	/** Collects the leaf view cells of the tree
 		@param viewCells returns the view cells 
@@ -279,16 +277,12 @@
 	bool ViewPointValid(const Vector3 &viewPoint) const;
 
-	/** Returns the view cell corresponding to 
-		the space outside the valid view space.
-	*/
-	BspViewCell *GetOutOfBoundsCell() const;
-
-	/** Writes tree to disc.
-	*/
-	bool WriteVspBspTree();
-
-	/** Loads tree from disc.
-	*/
-	bool LoadVspBspTree();
+	/** Returns view cell corresponding to 
+		the invalid view space.
+	*/
+	BspViewCell *GetOutOfBoundsCell();
+
+	/** Writes tree to output stream
+	*/
+	bool Export(ofstream &stream);
 
 protected:
@@ -321,4 +315,9 @@
 	};
 
+	/** Returns view cell corresponding to 
+		the invalid view space. If it does not exist, it is created.
+	*/
+	BspViewCell *GetOrCreateOutOfBoundsCell();
+
 	/** Collapses the tree with respect to the view cell partition,
 		i.e. leaves having the same view cell are collapsed.
@@ -329,4 +328,5 @@
 	*/
 	BspNode *CollapseTree(BspNode *node, int &collapsed);
+
 	/** Shuffles the leaves, i.e., tests if exchanging
 		the leaves helps in improving the view cells.
@@ -367,5 +367,7 @@
 	bool SelectPlane(Plane3 &plane, 
 					 BspLeaf *leaf, 
-					 VspBspTraversalData &data);
+					 VspBspTraversalData &data,
+					 VspBspTraversalData &frontData,
+					 VspBspTraversalData &backData);
 	
 	/** Strategies where the effect of the split plane is tested
@@ -375,6 +377,9 @@
 	*/
 	float SplitPlaneCost(const Plane3 &candidatePlane, 
-						 const VspBspTraversalData &data) const;
-
+						 const VspBspTraversalData &data,
+						 BspNodeGeometry &geomFront,
+						 BspNodeGeometry &geomBack,
+						 float &areaFront,
+						 float &areaBack) const;
 
 	/** Subdivide leaf.
@@ -397,17 +402,4 @@
 						   PolygonContainer &coincident);
 
-	/** Selects the split plane in order to construct a tree with
-		certain characteristics (e.g., balanced tree, least splits, 
-		2.5d aligned)
-		@param bestPlane returns the split plane
-		@param polygons container of polygons
-		@param rays bundle of rays on which the split can be based
-
-		@returns true if the overall cost is under maxCostRatio
-	*/
-	bool SelectPlaneHeuristics(Plane3 &bestPlane, 
-							   BspLeaf *leaf, 
-							   VspBspTraversalData &data);
-
 	/** Extracts the meshes of the objects and adds them to polygons. 
 		Adds object aabb to the aabb of the tree.
@@ -441,9 +433,8 @@
 								 const VspBspTraversalData &tData,
 								 int &axis,
-								 float &position,
-								 int &raysBack,
-								 int &raysFront,
-								 int &pvsBack,
-								 int &pvsFront);
+								 BspNodeGeometry **frontGeom,
+								 BspNodeGeometry **backGeom,
+								 float &frontArea,
+								 float &backArea);
 
 	/** Sorts split candidates for surface area heuristics for axis aligned splits.
@@ -506,5 +497,9 @@
 	
 	*/
-	void AddObjToPvs(Intersectable *obj, const int cf, int &frontPvs, int &backPvs) const;
+	void AddObjToPvs(Intersectable *obj, 
+					 const int cf, 
+					 int &frontPvs, 
+					 int &backPvs, 
+					 int &totalPvs) const;
 	
 	/** Computes PVS size induced by the rays.
@@ -591,8 +586,12 @@
 	void PropagateUpValidity(BspNode *node);
 
-	/** Creates or returns view cell corresponding to 
-		the space outside the valid view space.
-	*/
-	BspViewCell *GetOrCreateOutOfBoundsCell();
+	/** Writes the node to disk
+		@note: should be implemented as visitor
+	*/
+	void ExportNode(BspNode *node, ofstream &stream);
+
+	/** Returns memory usage of tree.
+	*/
+	float GetMemUsage() const;
 
 	/// Pointer to the root of the tree
@@ -621,13 +620,15 @@
 	/// mininum PVS
 	int mTermMinPvs;
-
-	/// minimal number of rays for axis aligned split
-	int mTermMinRaysForAxisAligned;
-	/// minimal number of objects for axis aligned split
-	int mTermMinObjectsForAxisAligned;
 	/// maximal contribution per ray
 	float mTermMaxRayContribution;
 	/// minimal accumulated ray length
 	float mTermMinAccRayLength;
+
+	//-- termination criteria for axis aligned split
+
+	/// minimal number of rays for axis aligned split
+	int mTermMinRaysForAxisAligned;
+	// max ray contribution
+	float mTermMaxRayContriForAxisAligned;
 
 	/// strategy to get the best split plane
@@ -684,6 +685,8 @@
 
 	MergeQueue mMergeQueue;
+
 	/// if rays should be used to collect merge candidates
 	bool mUseRaysForMerge;
+	
 	/// maximal allowed pvs so that view cell is valid
 	int mMaxPvs;
@@ -695,4 +698,10 @@
 	bool mShowInvalidSpace;
 
+	int mCurrentViewCellsId;
+
+	/// maximal tree memory
+	float mMaxMemory;
+
+	bool mOutOfMemory;
 private:
 	
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/X3dParser.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/X3dParser.cpp	(revision 490)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/X3dParser.cpp	(revision 508)
@@ -134,5 +134,5 @@
 	}
 	ptr = endptr;
-      }
+	  }
     }
   }
@@ -380,7 +380,7 @@
 
 
-/***********************************************************
- *         class X3dViewCellsParseHandlers implemenation   *
- ***********************************************************/
+/************************************************************************/
+/*             class X3dViewCellsParseHandlers implementation           */
+/************************************************************************/
 
 
@@ -534,15 +534,14 @@
   }
 	
-  // do nothing
-  //if (element == "Shape") {}
-  
   if (element == "Coordinate") {
 	  // add coordinates to the triangles
       StartCoordinate(attributes);
   }
+  // do nothing
+  //if (element == "Shape") {}
   // ignore material
   //if (element == "Material") {}
 
-  mElementCount++;
+  ++ mElementCount;
   mAttrCount += attributes.getLength();
 }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.h	(revision 508)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.h	(revision 508)
@@ -0,0 +1,23 @@
+#ifndef __VIEWCELLSDPARSER_H
+#define __VIEWCELLSDPARSER_H
+
+#include "Parser.h"
+#include "Containers.h"
+
+class ViewCellsManager;
+class VspBspTree;
+
+class ViewCellsParser : public Parser
+{
+public:
+  ViewCellsParser():Parser() {}
+  
+  //bool ParseFile(const string filename, ViewCellsManager &viewCells);
+  bool ParseFile(const string filename, 
+				 VspBspTree *tree, 
+				 ViewCellsManager *viewCells,
+				 ObjectContainer *objects);
+};
+
+
+#endif
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.h	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.h	(revision 508)
@@ -98,8 +98,16 @@
 	int CastRay(const Ray &ray, float &t, const float nearestT);
 
-	/** The polygon is triangulated.
+	/** The polygon is converted to triangles.
 	*/
 	void Triangulate(vector<Triangle3> &triangles);
-
+	/**
+		Adds polygon to mesh
+	*/
+	void AddToMesh(Mesh &mesh);
+	/** 
+		Triangle strip indices are created from this polgon.
+	*/
+	void Triangulate(VertexIndexContainer &indices);
+	
 	/** The piercing rays of the polygon are inherited by the child fragments
 		@parm front_piece the front fragment inheriting the front rays
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 508)
@@ -25,4 +25,7 @@
 	BspNodeGeometry()
 	{};  
+
+	// copy constructor copying the polygon array
+	BspNodeGeometry(const BspNodeGeometry &rhs);
 
 	~BspNodeGeometry();
@@ -330,4 +333,5 @@
 	/// leaf pvs
 	ObjectPvs *mPvs;
+
 	/// leaf area
 	float mArea;
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 508)
@@ -104,5 +104,5 @@
 		@return true on success
     */
-    bool LoadViewCells(const string filename);
+    virtual bool LoadViewCells(const string filename, ObjectContainer *objects);
 
 	/** Constructs view cell from base triangle. The ViewCell is extruded along the normal vector.
@@ -237,8 +237,15 @@
 	virtual void CreateMesh(ViewCell *vc) = NULL;
 
+	/** Writes view cells to disc.
+	*/
+	virtual bool ExportViewCells(const string filename);
+
 protected:
 
 	void ParseEnvironment();
 
+	/** Creates unique view cell ids.
+	*/
+	void CreateUniqueViewCellIds();
 	/** Recollects view cells and resets statistics.
 	*/
@@ -254,10 +261,9 @@
 	void EvaluateViewCellsStats();
 
-
 	//-- helper functions for view cell visualization
 
 	/** Exports the view cell partition.
 	*/
-	void ExportViewCells(Exporter *exporter) const;
+	void ExportViewCellsForViz(Exporter *exporter) const;
 
 	/** Sets exporter color.
@@ -272,4 +278,10 @@
 	*/
 	void CreateViewCellsMeshes();
+
+	/**
+		Exports single view cell.
+		NOTE: should be in exporter!!
+	*/
+	void ExportViewCell(ViewCell *viewCell, ofstream &stream);
 
 	/// the view cell corresponding to space ouside the valid view space
@@ -298,7 +310,8 @@
 	/// the scene bounding box
 	AxisAlignedBox3 mSceneBox;
-
+	/// holds the view cell meshes
 	MeshContainer mMeshContainer;
-
+	/// if view cells should be exported
+	bool mExportViewCells;
 	//-- visualization options
 	
@@ -551,9 +564,13 @@
 	void CreateMesh(ViewCell *vc);
 
+	bool LoadViewCells(const string filename, ObjectContainer *objects);
+	bool ExportViewCells(const string filename);
+
 protected:
 
 	/** Merges the view cells.
 	*/
-	void MergeViewCells(const VssRayContainer &rays, const ObjectContainer &objects);
+	void MergeViewCells(const VssRayContainer &rays, 
+						const ObjectContainer &objects);
 	
 	void RefineViewCells(const VssRayContainer &rays);
